package org.nakedobjects.nof.util.memento;

import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.IOException;

import org.nakedobjects.noa.NakedObjectRuntimeException;


public class BinaryTransferableReader extends AbstractTransferableReader {

    private DataInputStream dataInputStream;

    public BinaryTransferableReader(final byte[] data) {
        dataInputStream = new DataInputStream(new ByteArrayInputStream(data));
    }

    public int readInt() {
        try {
            return dataInputStream.readInt();
        } catch (IOException e) {
            throw new NakedObjectRuntimeException();
        }
    }

    public String readString() {
        try {
            return dataInputStream.readUTF();
        } catch (IOException e) {
            throw new NakedObjectRuntimeException();
        }
    }

    public long readLong() {
        try {
            return dataInputStream.readLong();
        } catch (IOException e) {
            throw new NakedObjectRuntimeException();
        }
    }

    public void close() {
        try {
            dataInputStream.close();
        } catch (IOException e) {
            throw new NakedObjectRuntimeException();
        }
    }
}
// Copyright (c) Naked Objects Group Ltd.
