package org.nakedobjects.nof.util.xmlsnapshot;

import java.io.CharArrayWriter;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;

import org.apache.crimson.tree.ElementNode2;
import org.apache.crimson.tree.XmlWriteContext;
import org.w3c.dom.Element;


public class DomSerializerCrimson implements DomSerializer {

    private static ElementNode2 assertCrimson(final Element domElement) {
        if (!(domElement instanceof ElementNode2)) {
            throw new IllegalArgumentException("Not using Crimson");
        }
        return (ElementNode2) domElement;
    }

    public String serialize(final Element domElement) {
        CharArrayWriter caw = new CharArrayWriter();
        try {
            serializeTo(domElement, caw);
            return caw.toString();
        } catch (IOException e) {
            return null;
        }
    }

    public void serializeTo(final Element domElement, final OutputStream os) throws IOException {
        OutputStreamWriter osw = new OutputStreamWriter(os);
        serializeTo(domElement, osw);
    }

    public void serializeTo(final Element domElement, final Writer w) throws IOException {
        ElementNode2 el = assertCrimson(domElement);
        XmlWriteContext xwc = new XmlWriteContext(w, 2);
        el.writeXml(xwc);
        xwc.getWriter().flush();
    }

}
// Copyright (c) Naked Objects Group Ltd.
